import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class MoveEffects here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class MoveEffects extends EffectedByGravity
{
    boolean collidedright = false;
    boolean collidedleft = false;
    public void act() 
    {
        
    }
    
    public void spin(int speed)
    {
        int rotation = getRotation();
        setRotation(rotation + (speed * 2));
    }
    
    public boolean detectCollision(Class item, int xcord, int ycord)
    {
        if (getOneObjectAtOffset( xcord, ycord, item) != null)
            return true;
        return false;
    }
    
    public int getNewSpeed(int speed)
    {
        if (getY() >= getWorld().getHeight() - 5 || getX() >= getWorld().getWidth() - 5 || getX() <= 5)
        {
            if (speed > 0)
                return speed - 1;
            else if (speed < 0)
                return speed + 1;
        }
        return speed;
    }
    
    public void bounce(int weight)
    {
        int y = getY();
        if (y >= getWorld().getHeight() - 5)
            gravityeffect = 0 - (gravityeffect * 5)/(5 + weight);
    }
    
    public void moveHorizontal(int speed)
    {
        int x = getX();
        int y = getY();
        if (x >= getWorld().getWidth() - 5)
        {
            collidedright = true;
            collidedleft = false;
        }
        else if (x <= 5)
        {
            collidedleft = true;
            collidedright = false;
        }
        if (speed >= 0)
        {
            if (collidedleft)
                setLocation(x + speed, y);
            else if (collidedright)
                setLocation(x - speed, y);
            else
                setLocation(x + speed, y);
        }
        else
        {
            if (collidedleft)
                setLocation(x - speed, y);
            else if (collidedright)
                setLocation(x + speed, y);
            else
                setLocation(x + speed, y);
        }
    }
    
    public void wrapHorizontal()
    {
        if (getX() >= getWorld().getWidth() - 5)
            setLocation(5, getY());
        else if (getX() <= 5)
            setLocation(getWorld().getWidth() - 5, getY());
    }
    
    public void wrapVertical()
    {
        if (getY() >= getWorld().getHeight() - 5)
            setLocation(getX(), 5);
        else if (getY() <= 5)
            setLocation(getX(), getWorld().getHeight() - 5);
    }
}
